OGRE: Ogre::MaterialManager Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::MaterialManager Class Reference
Core » Materials

Class for managing Material settings for Ogre. More...

`#include <OgreMaterialManager.h>`

Inheritance diagram for Ogre::MaterialManager:
[legend]

## Classes
class | Listener
| Listener on any general material events. More...

## Public Member Functions
| MaterialManager ()
| Default constructor.
virtual | ~MaterialManager ()
| Default destructor.
virtual Technique * | _arbitrateMissingTechniqueForActiveScheme (Material *mat, unsigned short lodIndex, const Renderable *rend)
| Internal method for sorting out missing technique for a scheme.
unsigned short | _getActiveSchemeIndex (void) const
| Internal method - returns the active scheme index.
virtual unsigned short | _getSchemeIndex (const String &name)
| Internal method - returns index for a given material scheme name.
virtual const String & | _getSchemeName (unsigned short index)
| Internal method - returns name for a given material scheme index.
virtual void | _notifyAfterIlluminationPassesCreated (Technique *mat)
| Internal method for sorting out illumination passes for a scheme.
virtual void | _notifyBeforeIlluminationPassesCleared (Technique *mat)
| Internal method for sorting out illumination passes for a scheme.
virtual void | addListener (Listener *l, const Ogre::String &schemeName=BLANKSTRING)
| Add a listener to handle material events.
MaterialPtr | create (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new material.
const String & | getActiveScheme (void) const
| Returns the name of the active material scheme.
MaterialPtr | getByName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME) const
| Get a material by name.
unsigned int | getDefaultAnisotropy () const
| Get the default maxAnisotropy.
MaterialPtr | getDefaultMaterial (bool useLighting=true)
| Get a default material that is always available even when no resources were loaded.
virtual MaterialPtr | getDefaultSettings (void) const
| Returns a pointer to the default Material settings.
virtual FilterOptions | getDefaultTextureFiltering (FilterType ftype) const
| Get the default texture filtering.
void | initialise (void)
| Initialises the material manager, which also triggers it to parse all available .program and .material scripts.
virtual void | removeListener (Listener *l, const Ogre::String &schemeName=BLANKSTRING)
| Remove a listener handling material events.
virtual void | setActiveScheme (const String &schemeName)
| Sets the name of the active material scheme.
void | setDefaultAnisotropy (unsigned int maxAniso)
| Sets the default anisotropy level to be used for loaded textures, for when textures are loaded automatically (e.g.
virtual void | setDefaultTextureFiltering (FilterOptions minFilter, FilterOptions magFilter, FilterOptions mipFilter)
| Sets the default texture filtering to be used for loaded textures, for when textures are loaded automatically (e.g.
virtual void | setDefaultTextureFiltering (FilterType ftype, FilterOptions opts)
| Sets the default texture filtering to be used for loaded textures, for when textures are loaded automatically (e.g.
virtual void | setDefaultTextureFiltering (TextureFilterOptions fo)
| Sets the default texture filtering to be used for loaded textures, for when textures are loaded automatically (e.g.
Public Member Functions inherited from Ogre::ResourceManager
| ResourceManager ()
virtual | ~ResourceManager ()
virtual void | _notifyResourceLoaded (Resource *res)
| Notify this manager that a resource which it manages has been loaded.
virtual void | _notifyResourceTouched (Resource *res)
| Notify this manager that a resource which it manages has been 'touched', i.e.
virtual void | _notifyResourceUnloaded (Resource *res)
| Notify this manager that a resource which it manages has been unloaded.
ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new resource, or retrieve an existing one with the same name if it already exists.
ResourcePtr | createResource (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Creates a new blank resource, but does not immediately load it.
void | destroyAllResourcePools ()
| destroy all pools
void | destroyResourcePool (const String &name)
| Destroy a resource pool.
void | destroyResourcePool (ResourcePool *pool)
| Destroy a resource pool.
virtual ResourcePtr | getByHandle (ResourceHandle handle) const
| Retrieves a pointer to a resource by handle, or null if the resource does not exist.
Real | getLoadingOrder (void) const override
| Gets the loading order for scripts of this type.
size_t | getMemoryBudget (void) const
| Get the limit on the amount of memory this resource handler may use.
size_t | getMemoryUsage (void) const
| Gets the current memory usage, in bytes.
virtual ResourcePtr | getResourceByName (const String &name, const String &groupName=RGN_DEFAULT) const
| Retrieves a pointer to a resource by name, or null if the resource does not exist.
ResourceMapIterator | getResourceIterator (void)
| Returns an iterator over all resources in this manager.
ResourcePool * | getResourcePool (const String &name)
| Create a resource pool, or reuse one that already exists.
const String & | getResourceType (void) const
| Gets a string identifying the type of resource this manager handles.
const StringVector & | getScriptPatterns (void) const override
| Gets the file patterns which should be used to find scripts for this class.
bool | getVerbose (void)
| Gets whether this manager and its resources habitually produce log output.
ResourcePtr | load (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters).
void | parseScript (DataStreamPtr &stream, const String &groupName) override
| Parse a script file.
ResourcePtr | prepare (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters).
void | reloadAll (bool reloadableOnly=true)
| Caused all currently loaded resources to be reloaded.
virtual void | reloadAll (Resource::LoadingFlags flags)
| Caused all currently loaded resources to be reloaded.
void | reloadUnreferencedResources (bool reloadableOnly=true)
| Caused all currently loaded but not referenced by any other object resources to be reloaded.
void | remove (const ResourcePtr &r)
| Remove a single resource.
void | remove (const String &name, const String &group=RGN_DEFAULT)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | remove (ResourceHandle handle)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | removeAll (void)
| Removes all resources.
virtual void | removeUnreferencedResources (bool reloadableOnly=true)
| Remove all resources which are not referenced by any other object.
bool | resourceExists (const String &name, const String &group=RGN_DEFAULT) const
| Returns whether the named resource exists in this manager.
bool | resourceExists (ResourceHandle handle) const
| Returns whether a resource with the given handle exists in this manager.
void | setMemoryBudget (size_t bytes)
| Set a limit on the amount of memory this resource handler may use.
void | setVerbose (bool v)
| Sets whether this manager and its resources habitually produce log output.
void | unload (const String &name, const String &group=RGN_DEFAULT)
| Unloads a single resource by name.
void | unload (ResourceHandle handle)
| Unloads a single resource by handle.
void | unloadAll (bool reloadableOnly=true)
| Unloads all resources.
virtual void | unloadAll (Resource::LoadingFlags flags)
| Unloads all resources.
void | unloadUnreferencedResources (bool reloadableOnly=true)
| Unload all resources which are not referenced by any other object.
Public Member Functions inherited from Ogre::ScriptLoader
virtual | ~ScriptLoader ()
Public Member Functions inherited from Ogre::Singleton< MaterialManager >
| ~Singleton (void)

## Static Public Member Functions
static MaterialManager & | getSingleton (void)
| Get the singleton instance.
static MaterialManager * | getSingletonPtr (void)
| Get the singleton instance.
Static Public Member Functions inherited from Ogre::Singleton< MaterialManager >
static MaterialManager & | getSingleton (void)
| Get the singleton instance.
static MaterialManager * | getSingletonPtr (void)
| Get the singleton instance.

## Static Public Attributes
static String | DEFAULT_SCHEME_NAME
| same as MSN_DEFAULT

## Additional Inherited Members
Public Types inherited from Ogre::ResourceManager
typedef std::pair< ResourcePtr, bool > | ResourceCreateOrRetrieveResult
typedef std::map< ResourceHandle, ResourcePtr > | ResourceHandleMap
typedef std::unordered_map< String, ResourcePtr > | ResourceMap
typedef MapIterator< ResourceHandleMap > | ResourceMapIterator
typedef std::unordered_map< String, ResourceMap > | ResourceWithGroupMap

## Detailed Description

Class for managing Material settings for Ogre.

Materials control the eventual surface rendering properties of geometry. This class manages the library of materials, dealing with programmatic registrations and lookups, as well as loading predefined Material settings from scripts.

When loaded from a script, a Material is in an 'unloaded' state and only stores the settings required. It does not at that stage load any textures. This is because the material settings may be loaded 'en masse' from bulk material script files, but only a subset will actually be required.

Because this is a subclass of ResourceManager, any files loaded will be searched for in any path or archive added to the resource paths/archives. See ResourceManager for details.

For a definition of the material script format, see Material Scripts.

Ogre comes configured with a set of defaults for newly created materials. If you wish to have a different set of defaults, simply call getDefaultSettings() and change the returned Material's settings. All materials created from then on will be configured with the new defaults you have specified.

## Constructor & Destructor Documentation

## ◆ MaterialManager()

Ogre::MaterialManager::MaterialManager | ( |  | ) |

Default constructor.

Referenced by getSingleton(), and getSingletonPtr().

## ◆ ~MaterialManager()

virtual Ogre::MaterialManager::~MaterialManager | ( |  | ) |
| virtual

Default destructor.

## Member Function Documentation

## ◆ create()

MaterialPtr Ogre::MaterialManager::create | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0,
|  | const NameValuePairList * | createParams = 0 )

Create a new material.

See also
  ResourceManager::createResource

## ◆ getByName()

MaterialPtr Ogre::MaterialManager::getByName | ( | const String & | name,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME ) const

Get a material by name.

For example, to get a MaterialPtr to a material defined in .material script.

See also
  ResourceManager::getResourceByName

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME.

## ◆ getDefaultMaterial()

MaterialPtr Ogre::MaterialManager::getDefaultMaterial | ( | bool | useLighting = true | ) |

Get a default material that is always available even when no resources were loaded.

Parameters

  useLighting | whether the material should be lit

## ◆ initialise()

void Ogre::MaterialManager::initialise | ( | void |  | ) |

Initialises the material manager, which also triggers it to parse all available .program and .material scripts.

## ◆ setDefaultTextureFiltering() [1/3]

virtual void Ogre::MaterialManager::setDefaultTextureFiltering | ( | TextureFilterOptions | fo | ) |
| virtual

Sets the default texture filtering to be used for loaded textures, for when textures are loaded automatically (e.g.

by Material class) or when 'load' is called with the default parameters by the application.

Note
  The default value is TFO_BILINEAR.

## ◆ setDefaultTextureFiltering() [2/3]

virtual void Ogre::MaterialManager::setDefaultTextureFiltering | ( | FilterType | ftype,
|  | FilterOptions | opts )
| virtual

Sets the default texture filtering to be used for loaded textures, for when textures are loaded automatically (e.g.

by Material class) or when 'load' is called with the default parameters by the application.

## ◆ setDefaultTextureFiltering() [3/3]

virtual void Ogre::MaterialManager::setDefaultTextureFiltering | ( | FilterOptions | minFilter,
|  | FilterOptions | magFilter,
|  | FilterOptions | mipFilter )
| virtual

Sets the default texture filtering to be used for loaded textures, for when textures are loaded automatically (e.g.

by Material class) or when 'load' is called with the default parameters by the application.

## ◆ getDefaultTextureFiltering()

virtual FilterOptions Ogre::MaterialManager::getDefaultTextureFiltering | ( | FilterType | ftype | ) | const
| virtual

Get the default texture filtering.

## ◆ setDefaultAnisotropy()

void Ogre::MaterialManager::setDefaultAnisotropy | ( | unsigned int | maxAniso | ) |

Sets the default anisotropy level to be used for loaded textures, for when textures are loaded automatically (e.g.

by Material class) or when 'load' is called with the default parameters by the application.

Note
  The default value is 1 (no anisotropy).

## ◆ getDefaultAnisotropy()

unsigned int Ogre::MaterialManager::getDefaultAnisotropy | ( |  | ) | const

Get the default maxAnisotropy.

## ◆ getDefaultSettings()

virtual MaterialPtr Ogre::MaterialManager::getDefaultSettings | ( | void |  | ) | const
| inlinevirtual

Returns a pointer to the default Material settings.

The default settings begin as a single Technique with a single, non-programmable Pass:

- ambient = ColourValue::White
- diffuse = ColourValue::White
- specular = ColourValue::Black
- emissive = ColourValue::Black
- shininess = 0 (not shiny)
- SourceBlendFactor = Ogre::SBF_ONE
- DestBlendFactor = Ogre::SBF_ZERO (no blend, replace with new colour)
- Depth buffer checking on
- Depth buffer writing on
- Depth buffer comparison function = Ogre::CMPF_LESS_EQUAL
- Colour buffer writing on for all channels
- Culling mode = Ogre::CULL_CLOCKWISE
- Ambient lighting = ColourValue(0.5, 0.5, 0.5) (mid-grey)
- Dynamic lighting enabled
- Gourad shading mode
- No texture unit settings (& hence no textures)

## ◆ _getSchemeIndex()

virtual unsigned short Ogre::MaterialManager::_getSchemeIndex | ( | const String & | name | ) |
| virtual

Internal method - returns index for a given material scheme name.

See also
  Technique::setSchemeName

## ◆ _getSchemeName()

virtual const String & Ogre::MaterialManager::_getSchemeName | ( | unsigned short | index | ) |
| virtual

Internal method - returns name for a given material scheme index.

See also
  Technique::setSchemeName

## ◆ _getActiveSchemeIndex()

unsigned short Ogre::MaterialManager::_getActiveSchemeIndex | ( | void |  | ) | const
| inline

Internal method - returns the active scheme index.

See also
  Technique::setSchemeName

## ◆ getActiveScheme()

const String & Ogre::MaterialManager::getActiveScheme | ( | void |  | ) | const
| inline

Returns the name of the active material scheme.

See also
  Technique::setSchemeName

## ◆ setActiveScheme()

virtual void Ogre::MaterialManager::setActiveScheme | ( | const String & | schemeName | ) |
| virtual

Sets the name of the active material scheme.

See also
  Technique::setSchemeName

## ◆ addListener()

virtual void Ogre::MaterialManager::addListener | ( | Listener * | l,
|  | const Ogre::String & | schemeName = BLANKSTRING )
| virtual

Add a listener to handle material events.

If schemeName is supplied, the listener will only receive events for that certain scheme.

References Ogre::BLANKSTRING.

## ◆ removeListener()

virtual void Ogre::MaterialManager::removeListener | ( | Listener * | l,
|  | const Ogre::String & | schemeName = BLANKSTRING )
| virtual

Remove a listener handling material events.

If the listener was added with a custom scheme name, it needs to be supplied here as well.

References Ogre::BLANKSTRING.

## ◆ _arbitrateMissingTechniqueForActiveScheme()

virtual Technique * Ogre::MaterialManager::_arbitrateMissingTechniqueForActiveScheme | ( | Material * | mat,
|  | unsigned short | lodIndex,
|  | const Renderable * | rend )
| virtual

Internal method for sorting out missing technique for a scheme.

## ◆ _notifyAfterIlluminationPassesCreated()

virtual void Ogre::MaterialManager::_notifyAfterIlluminationPassesCreated | ( | Technique * | mat | ) |
| virtual

Internal method for sorting out illumination passes for a scheme.

## ◆ _notifyBeforeIlluminationPassesCleared()

virtual void Ogre::MaterialManager::_notifyBeforeIlluminationPassesCleared | ( | Technique * | mat | ) |
| virtual

Internal method for sorting out illumination passes for a scheme.

## ◆ getSingleton()

MaterialManager & Ogre::MaterialManager::getSingleton | ( | void |  | ) |
| static

Get the singleton instance.

References MaterialManager().

## ◆ getSingletonPtr()

MaterialManager * Ogre::MaterialManager::getSingletonPtr | ( | void |  | ) |
| static

Get the singleton instance.

References MaterialManager().

## Member Data Documentation

## ◆ DEFAULT_SCHEME_NAME

String Ogre::MaterialManager::DEFAULT_SCHEME_NAME
| static

same as MSN_DEFAULT

The documentation for this class was generated from the following file:

- OgreMaterialManager.h